"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _MapViewManager = require("./MapViewManager");
var _SendCommand = require("./SendCommand");
var _Compass = _interopRequireDefault(require("./Compass"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const MapView = (props, parentRef) => {
  const nodeRef = (0, _react.useRef)(null);
  const compassStyle = _reactNative.StyleSheet.create({
    compass: {
      height: 64,
      width: 64,
      borderRadius: 5,
      marginVertical: 40,
      // backgroundColor: '#61dafb',
      alignItems: 'center',
      justifyContent: 'center',
      zIndex: 1,
      position: 'absolute',
      right: '10%',
      top: '10%',
      flex: 1,
      resizeMode: 'contain'
    }
  });
  const [compassTransform, setCompassTransform] = (0, _react.useState)({
    rotate: '0deg'
  });
  const [onNavigationPathGeneratedValue, setOnNavigationPathGeneratedValue] = (0, _react.useState)(null);
  const [onDestinationSelectedValue, setOnDestinationSelectedValue] = (0, _react.useState)(null);
  const [onUserPositionUpdatedValue, setOnUserPositionUpdatedValue] = (0, _react.useState)(null);
  const [onSearchDestinationsGeneratedValue, setOnSearchDestinationsGeneratedValue] = (0, _react.useState)(null);
  const [onMapTappedGenericValue, setOnMapTappedGenericValue] = (0, _react.useState)(null);
  // const [onScreenRotated, setOnScreenRotated] =
  //   useState<SCREEN_ROTATED_EVENT | null>(null);

  const [onErrorValue, setOnErrorValue] = (0, _react.useState)(null);
  const [onVenueLoadedValue, setOnVenueLoadedValue] = (0, _react.useState)(null);
  const [onGeofencesChangedValue, setOnGeofencesChangedValue] = (0, _react.useState)(null);
  (0, _react.useEffect)(() => {
    if (_reactNative.Platform.OS == 'android') {
      (0, _SendCommand.createFragment)((0, _reactNative.findNodeHandle)(nodeRef.current));
    }
    setTimeout(function () {
      (0, _SendCommand.setMapVenue)({
        viewId: (0, _reactNative.findNodeHandle)(nodeRef.current),
        credentials: props.credentials,
        mapOptions: props.mapOptions
      });
    }, 500);
  }, []);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o, _props$onMapMessage;
    if (onDestinationSelectedValue != null) (_props$onMapMessage$o = (_props$onMapMessage = props.onMapMessage).onDestinationSelected) === null || _props$onMapMessage$o === void 0 || _props$onMapMessage$o.call(_props$onMapMessage, onDestinationSelectedValue);
  }, [onDestinationSelectedValue]);
  (0, _react.useEffect)(() => {
    if (onNavigationPathGeneratedValue != null) {
      var _props$onMapMessage$o2, _props$onMapMessage2;
      let pathId, instructions, start, end, path;
      ({
        pathId,
        instructions,
        start,
        end,
        path
      } = onNavigationPathGeneratedValue);
      (_props$onMapMessage$o2 = (_props$onMapMessage2 = props.onMapMessage).onNavigationPathGenerated) === null || _props$onMapMessage$o2 === void 0 || _props$onMapMessage$o2.call(_props$onMapMessage2, pathId, instructions, start, end, path);
    }
  }, [onNavigationPathGeneratedValue]);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o3, _props$onMapMessage3;
    if (onUserPositionUpdatedValue != null) (_props$onMapMessage$o3 = (_props$onMapMessage3 = props.onMapMessage).onUserPositionUpdated) === null || _props$onMapMessage$o3 === void 0 || _props$onMapMessage$o3.call(_props$onMapMessage3, onUserPositionUpdatedValue);
  }, [onUserPositionUpdatedValue]);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o4, _props$onMapMessage4;
    if (onSearchDestinationsGeneratedValue != null) (_props$onMapMessage$o4 = (_props$onMapMessage4 = props.onMapMessage).onSearchDestinationsGenerated) === null || _props$onMapMessage$o4 === void 0 || _props$onMapMessage$o4.call(_props$onMapMessage4, onSearchDestinationsGeneratedValue);
  }, [onSearchDestinationsGeneratedValue]);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o5, _props$onMapMessage5;
    if (onMapTappedGenericValue != null) (_props$onMapMessage$o5 = (_props$onMapMessage5 = props.onMapMessage).onMapTappedGeneric) === null || _props$onMapMessage$o5 === void 0 || _props$onMapMessage$o5.call(_props$onMapMessage5, onMapTappedGenericValue);
  }, [onMapTappedGenericValue]);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o6, _props$onMapMessage6;
    if (onErrorValue != null) (_props$onMapMessage$o6 = (_props$onMapMessage6 = props.onMapMessage).onError) === null || _props$onMapMessage$o6 === void 0 || _props$onMapMessage$o6.call(_props$onMapMessage6, onErrorValue);
  }, [onErrorValue]);
  (0, _react.useEffect)(() => {
    var _props$onMapMessage$o7, _props$onMapMessage7;
    if (onVenueLoadedValue != null) (_props$onMapMessage$o7 = (_props$onMapMessage7 = props.onMapMessage).onVenueLoaded) === null || _props$onMapMessage$o7 === void 0 || _props$onMapMessage$o7.call(_props$onMapMessage7, onVenueLoadedValue);
  }, [onVenueLoadedValue]);
  // useEffect(() => {
  //   if (onScreenRotated != null)
  //     props.onMapMessage.onScreenRotated?.(onScreenRotated);
  // }, [onScreenRotated]);
  (0, _react.useEffect)(() => {
    if (onGeofencesChangedValue != null) {
      var _props$onMapMessage$o8, _props$onMapMessage8;
      let entered, geofences;
      ({
        entered,
        geofences
      } = onGeofencesChangedValue);
      console.log("Geofences Changed: ", entered, geofences);
      (_props$onMapMessage$o8 = (_props$onMapMessage8 = props.onMapMessage).onGeofencesChanged) === null || _props$onMapMessage$o8 === void 0 || _props$onMapMessage$o8.call(_props$onMapMessage8, entered, geofences);
    }
  }, [onGeofencesChangedValue]);
  (0, _react.useImperativeHandle)(parentRef, () => {
    const viewId = (0, _reactNative.findNodeHandle)(nodeRef.current);
    const listeners = {
      setMapVenue: (credentials, mapOptions) => {
        setTimeout(function () {
          (0, _SendCommand.setMapVenue)({
            viewId,
            credentials,
            mapOptions
          });
        }, 500);
      },
      centerMapOnUser: function (orientation) {
        let zoom = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5;
        let animationDuration = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1000;
        (0, _SendCommand.centerMap)(viewId, orientation, zoom, animationDuration);
      },
      setFollowBlueDot: function (enabled) {
        let rotate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        let interval = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 500;
        (0, _SendCommand.setFollowBlueDot)(viewId, enabled, rotate, interval);
      },
      setUserPosition: (lat, long, heading, confidence) => {
        (0, _SendCommand.setUserPosition)(viewId, lat, long, heading, confidence, null);
      },
      setUserPositionXY: (x, y, heading, confidence) => {
        (0, _SendCommand.setUserPosition)(viewId, x, y, heading, confidence, 'xy');
      },
      clearWayfindingPath: () => {
        (0, _SendCommand.clearWayfindingPath)(viewId);
      },
      wayfindToWaypoint: waypointId => {
        (0, _SendCommand.wayfindToWaypoint)(viewId, waypointId);
      },
      wayfindBetweenWaypoints: (originId, destinationId) => {
        (0, _SendCommand.wayfindBetweenWaypoints)(viewId, originId, destinationId);
      },
      drawNavigationPath: (pathId, _ref) => {
        let {
          shouldFocus,
          style,
          originIcon,
          destinationIcon
        } = _ref;
        (0, _SendCommand.drawNavigationPath)(viewId, pathId, shouldFocus ?? true, style ?? {}, originIcon, destinationIcon);
      },
      styleUnitsForDestination: (destinationId, style) => {
        (0, _SendCommand.styleUnitsForDestination)(viewId, destinationId, style);
      },
      addMapIcon: (coordinates, coordType, icon) => {
        (0, _SendCommand.addMapIcon)(viewId, coordinates, coordType, icon);
      }
    };
    return listeners;
  });
  (0, _react.useEffect)(() => {
    var _eventEmitter, _eventEmitter2, _eventEmitter3, _eventEmitter4, _eventEmitter5, _eventEmitter6, _eventEmitter7, _eventEmitter8, _eventEmitter9;
    console.log('Initializing Event Emitter');
    let eventEmitter = null;
    if (_reactNative.Platform.OS == 'android') {
      eventEmitter = _reactNative.DeviceEventEmitter;
    } else if (_reactNative.Platform.OS == 'ios') {
      console.log(_MapViewManager.CTPEventEmitter);
      eventEmitter = new _reactNative.NativeEventEmitter(_MapViewManager.CTPEventEmitter);
    }
    (_eventEmitter = eventEmitter) === null || _eventEmitter === void 0 || _eventEmitter.addListener('DESTINATION_SELECTED', data => setOnDestinationSelectedValue(data));
    (_eventEmitter2 = eventEmitter) === null || _eventEmitter2 === void 0 || _eventEmitter2.addListener('NAVIGATION_PATH_GENERATED', data => setOnNavigationPathGeneratedValue(data));
    (_eventEmitter3 = eventEmitter) === null || _eventEmitter3 === void 0 || _eventEmitter3.addListener('USER_POSITION_UPDATED', userPosition => setOnUserPositionUpdatedValue(userPosition));
    (_eventEmitter4 = eventEmitter) === null || _eventEmitter4 === void 0 || _eventEmitter4.addListener('GENERATED_SEARCH_DESTINATIONS', destinations => setOnSearchDestinationsGeneratedValue(destinations));

    // eventEmitter?.addListener('WINDOW_LOADED', () =>
    //   props.onMapMessage.onWindowLoaded?.()
    // );
    (_eventEmitter5 = eventEmitter) === null || _eventEmitter5 === void 0 || _eventEmitter5.addListener('MAP_TAPPED_GENERIC', event => setOnMapTappedGenericValue(event));
    (_eventEmitter6 = eventEmitter) === null || _eventEmitter6 === void 0 || _eventEmitter6.addListener('SCREEN_ROTATED', event => {
      // setOnScreenRotated(event);
      const newTransform = {
        rotate: Math.round(event.degrees).toString() + 'deg'
      };
      setCompassTransform(newTransform);
    }
    // props.onMapMessage.onMapTappedGeneric?.(data)
    );

    (_eventEmitter7 = eventEmitter) === null || _eventEmitter7 === void 0 || _eventEmitter7.addListener('ERROR', msg => setOnErrorValue(msg));
    (_eventEmitter8 = eventEmitter) === null || _eventEmitter8 === void 0 || _eventEmitter8.addListener('VENUE_LOADED', venueId => setOnVenueLoadedValue(venueId));
    (_eventEmitter9 = eventEmitter) === null || _eventEmitter9 === void 0 || _eventEmitter9.addListener('GEOFENCES_CHANGED', data => setOnGeofencesChangedValue(data));
    return () => {
      var _eventEmitter10, _eventEmitter11, _eventEmitter12, _eventEmitter13, _eventEmitter14, _eventEmitter15, _eventEmitter16, _eventEmitter17, _eventEmitter18;
      console.log('Removing Event Emitters');
      (_eventEmitter10 = eventEmitter) === null || _eventEmitter10 === void 0 || _eventEmitter10.removeAllListeners('DESTINATION_SELECTED');
      (_eventEmitter11 = eventEmitter) === null || _eventEmitter11 === void 0 || _eventEmitter11.removeAllListeners('NAVIGATION_PATH_GENERATED');
      (_eventEmitter12 = eventEmitter) === null || _eventEmitter12 === void 0 || _eventEmitter12.removeAllListeners('USER_POSITION_UPDATED');
      (_eventEmitter13 = eventEmitter) === null || _eventEmitter13 === void 0 || _eventEmitter13.removeAllListeners('GENERATED_SEARCH_DESTINATIONS');
      (_eventEmitter14 = eventEmitter) === null || _eventEmitter14 === void 0 || _eventEmitter14.removeAllListeners('MAP_TAPPED_GENERIC');
      (_eventEmitter15 = eventEmitter) === null || _eventEmitter15 === void 0 || _eventEmitter15.removeAllListeners('ERROR');
      (_eventEmitter16 = eventEmitter) === null || _eventEmitter16 === void 0 || _eventEmitter16.removeAllListeners('VENUE_LOADED');
      (_eventEmitter17 = eventEmitter) === null || _eventEmitter17 === void 0 || _eventEmitter17.removeAllListeners('SCREEN_ROTATED');
      (_eventEmitter18 = eventEmitter) === null || _eventEmitter18 === void 0 || _eventEmitter18.removeAllListeners('GEOFENCES_CHANGED');
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(_reactNative.SafeAreaView, {
    style: {
      flex: 1,
      width: '100%',
      height: '100%'
    }
  }, /*#__PURE__*/_react.default.createElement(_Compass.default, {
    style: [compassStyle.compass, {
      transform: [compassTransform]
    }]
  }), /*#__PURE__*/_react.default.createElement(_reactNative.SafeAreaView, null), _MapViewManager.MapViewManager ? /*#__PURE__*/_react.default.createElement(_MapViewManager.MapViewManager, {
    style: _reactNative.Platform.OS == 'android' ? {
      // converts dpi to px, provide desired height
      height: _reactNative.PixelRatio.getPixelSizeForLayoutSize(props.style.height),
      // converts dpi to px, provide desired width
      width: _reactNative.PixelRatio.getPixelSizeForLayoutSize(props.style.width)
    } : {
      height: props.style.height / 1,
      width: props.style.width / 1
      // converts dpi to px, provide desired height
      // height: PixelRatio.getPixelSizeForLayoutSize(props.style.height),
      // converts dpi to px, provide desired width
      // width: PixelRatio.getPixelSizeForLayoutSize(props.style.width),
    },

    ref: nodeRef
  }) : null);
};
const mapViewFwRef = /*#__PURE__*/(0, _react.forwardRef)(MapView);
// mapViewFwRef.propTypes = {
//   eventEmitter: PropTypes.
// }
var _default = mapViewFwRef;
exports.default = _default;
//# sourceMappingURL=MapView.js.map